<?php
  class PHPGravatar {
    var $GRAVATAR_BASE='http://gravatar.com/avatar/%s?&s=%s&r=%s&d=%s';
    var $GRAVATAR_CACHE_LOCATION='gravatar_cache/%s-%s-%s.jpg';
    var $GRAVATAR_CACHE_EXPIRE='5 days';
    var $rating="pg";
    var $size=80;
    var $email;
    var $email_md5;
    var $default;
    var $cache;
    var $cache_location="";
    function PHPGravatar() {
      $this->size=80;
      $this->rating="pg";
      $this->cache=(ini_get("allow_url_fopen")==1?true:false);
    }
    function disableCache() {
      $this->cache=false;
      return $this;
    }
    function setCacheLocation($location) {
      $this->cache_location=$location;
    }
    function setEmail($email) {
      $email_lowercase=(string) strtolower($email);
      $this->email=$email_lowercase;
      $this->email_md5=md5($email_lowercase);
      return $this;
    }
    function setRating($rating="pg") {
      $acceptable=array("any","g","pg","r","x");
      if(in_array($rating,$acceptable)) {
        $this->rating=strtolower($rating);
      }
      else{
        $this->rating="pg";
      }
      return $this;
    }
    function setDefault($image_url) {
      $this->default=(string) urlencode($image_url);
      return $this;
    }
    function setSize($size) {
      $s=(int) $size;
      if($s>1&&$s<512) {
        $this->size=$s;
      }
      else{
        $this->size=80;
      }
      return $this;
    }
    function get() {
      $gravatar_url=(string) sprintf($this->GRAVATAR_BASE,$this->email_md5,$this->size,$this->rating,$this->default);
      if($this->cache) {
        $filename='';
        $filename=(string) $this->cache_location.sprintf($this->GRAVATAR_CACHE_LOCATION,$this->email_md5,$this->size,$this->rating);
        if(file_exists($filename)) {
          if((filemtime($filename)>strtotime('-'.$this->GRAVATAR_CACHE_EXPIRE))) {
            return $filename;
          }
        }
        @copy($gravatar_url,$filename);
        if(file_exists($filename)) {
          return $filename;
        }
        else{
          return $gravatar_url;
        }
      }
      else{
        return $gravatar_url;
      }
    }
    function getTag() {
      $image='<img src="'.$this->get().'" style="border:1px solid #ccc;margin:2px;padding:4px;background-color:#fff" alt="Gravatar" />';
      return $image;
    }
  }
?>
