<?php
/*
*
* datsogallery_Sef - open source sef_ext.php module.
*
* Based on the Ponygallery_SEF by Risto Treksler
* Copyright (C) 2006 Risto Treksler aka irstudio, risto@elkhornbanff.ca, http://risto.cjb.net/
*
** Copyright (C) 2007 Kevin Hayne, Kevin@kahstudios.com, http://www.kahstudios.com/
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Comments: for Joomla! 1.0.7+ and OpenSEF 2.0.0-RC1+ and Open-SEF
* Note: class must be named after the exact componentname
*/
class sef_datsogallery {
    /**
    * Creates the Open-SEF URL out of the Joomla request
    * Input: $string, string, The request URL (index.php?option=com_example&Itemid=$Itemid)
    * Output: $sefstring, string, Open-SEF URL ($var1/$var2/)
    **/
    function create ($string) {
    
        global $database, $sefConfig, $sufix,$longurl;
    
        if (empty($sefConfig)) {
            $ext_suffix = $sufix;
            $ext_url = $longurl;
        } else {
            $ext_suffix = $sefConfig->encode_page_suffix;
            $ext_url = $sefConfig->category_title_field;
        }
        // $string == "index.php?option=com_example&Itemid=$Itemid&var1=$var1&var2=$var2"
        $sefstring = "";
        $string = str_replace( '&amp;', '&', $string );
        /*---------------------------------------------------------------------------*/
        // description: display pictures
        // func=detail, id=$var1
        if (eregi("&func=detail",$string) &&
            eregi("&id=",$string)) {
            if (eregi("&id=",$string)) {
                $temp = split("&id=", $string);
                $temp = split("&", $temp[1]);
                $imgid = $temp[0];
                //figure out the category for this image
                $database->setQuery("SELECT catid, imgtitle FROM #__datsogallery WHERE id=".$imgid);
                $result = $database->loadObjectList();
                $photo = $result[0];
                $catid = $photo->catid;
                $catnames = array();
                //figure out the category name and add to path
                while ( $catid != 0 ) {
                    $database->setQuery("SELECT name, parent FROM #__datsogallery_catg WHERE cid=".$catid);
                    $result = $database->loadObjectList();
                    $category = $result[0];
                    //add category names to array to later read in reverse
                    array_unshift($catnames, $category->name);
                    //$sefstring .= datso_sefencode($category->name).'/';
                    $catid=$category->parent;
                }
                $sefstring .= "category/";
                foreach ( $catnames as $catname ) {
                    $sefstring .= datso_sefencode($catname).'/';
                }
                //add the image title to path
                $sefstring .= "photo_".datso_sefencode($photo->imgtitle);
            }
            return $sefstring.$ext_suffix;
        }
        /*---------------------------------------------------------------------------*/
        // description: display categories
        // func=viewcategory, catid=$var1 startpage=$var2
        elseif (eregi("&func=viewcategory",$string) &&
            eregi("&catid=",$string)) {
            if (eregi("&catid=",$string)) {
            	$sefstring .= "category/";
                $temp = split("&catid=", $string);
                $temp = split("&", $temp[1]);
                $catid = $temp[0];
                $catnames = array();
                //figure out the category name and add to path
                while ( $catid != 0 ) {
                    $database->setQuery("SELECT name, parent FROM #__datsogallery_catg WHERE cid=".$catid);
                    $result = $database->loadObjectList();
                    $category = $result[0];
                    //add category names to array to later read in reverse
                    array_unshift($catnames, $category->name);
                    //$sefstring .= datso_sefencode($category->name).'/';
                    $catid=$category->parent;
                } 
                foreach ( $catnames as $catname ) {
                    $sefstring .= datso_sefencode($catname).'/';
                }
            }
            if (eregi("&startpage=",$string)) {
                $temp = split("&startpage=", $string);
                $temp = split("&", $temp[1]);
                $pagenm = $temp[0];
                
				$sefstring .= "pg".$pagenm.'.html';
            }
            
            
            
            return $sefstring;
        }
        /*---------------------------------------------------------------------------*/
        // description: display special pages
        // func=viewcategory, catid=$var1
        elseif (eregi("&func=special",$string)) {
            if (eregi("&sorting=",$string)) {
                $temp = split("&sorting=", $string);
                $temp = split("&", $temp[1]);
                $special_type = $temp[0];
                
                switch($special_type) {
					case "rating":
						$sefstring .= 'special/top_rated/';
						break;
					case "lastadd":
						$sefstring .= 'special/last_added/';
						break;
					case "lastcomment":
						$sefstring .= 'special/last_commented/';		
						break;
				}
            } else {
				$sefstring .= 'special/most_viewed/';
			}
            return $sefstring;
        }
        
        
        /*---------------------------------------------------------------------------*/
        // description: handle tasks that don't have parameters
        // variables: NULL
        elseif (eregi("&func=savepic",$string) 
        || eregi("&func=showupload",$string) 
        || eregi("&func=suploadhandler",$string) 
        || eregi("&func=send2friend",$string) 
        || eregi("&func=userpannel",$string)) {
            if (eregi("&func=userpannel",$string)) {
                $sefstring .= "control_panel/";
            }
            else {
                $temp = split("&func=", $string);
                $temp = split("&", $temp[1]);
                $sefstring .= $temp[0]."/";
            }
            return $sefstring;
        }
        /*---------------------------------------------------------------------------*/
        // description: passthrough some variables
        // variables: translated to standard joomla core sef 
        elseif (eregi("&func=editpic",$string)
        || eregi("&func=deletepic",$string)
        || eregi("&func=votepic",$string)
        || eregi("&func=commentpic",$string)  
        || eregi("&func=deletecomment",$string)) {
            $temp         = split("\?option=com_datsogallery", $string);
            $temp         = split('&', $temp[1]);
            foreach($temp as $key => $value) {
                $tmpstring = split('=', $value);
                if ( $tmpstring[0] == 'Itemid' ) {
                    $tmpid = $tmpstring[1];
                }
                else {
                	if($value) {
	                    $sefstring .= $value.'/';
	                }
                }                
            }
            $sefstring .= 'Itemid='.$tmpid.'/';
            $string = str_replace( '=', ',', $sefstring );
            return $string;
        }
    }

    /**
    * Reverts to the Joomla query string out of the Open-SEF URL
    * Input:
    *    $url_array, array, The Open-SEF URL split in arrays (first custom virtual directory beginning at $pos+1)
    *    $pos, int, The position of the first virtual directory (component)
    * Output: $QUERY_STRING, string, Joomla query string (var1=$var1&var2=$var2)
    *    Note that this will be added to already defined first part (option=com_example&Itemid=$Itemid)
    **/
    function revert ($url_array, $pos) {
		//die(print_r($url_array));
		// define all variables you pass as globals
        global $database, $sefConfig, $longurl;
        if (empty($sefConfig)) {
            $ext_url = $longurl;
        } else {
            $ext_url = $sefConfig->category_title_field;
        }
        // Examine the SEF advance URL and extract the variables building the query string
        $QUERY_STRING = "";
        $database->setQuery("SELECT id "
        ."FROM #__menu "
        ."WHERE link='index.php?option=com_datsogallery'");
        $Itemid = $database->loadResult();
        $_GET['Itemid'] = $Itemid;
        $_REQUEST['Itemid'] = $Itemid;
        $QUERY_STRING .= "option=com_datsogallery&Itemid=$Itemid";
        $pos=0;
        /*---------------------------------------------------------------------------*/
        // description: handle tasks that don't have parameters
        // variables: NULL
		if (isset($url_array[$pos+2]) && $url_array[$pos+2] !="" &&
            ($url_array[$pos+2]   == "savepic" ||
            $url_array[$pos+2]    == "showupload" ||
            $url_array[$pos+2]    == "uploadhandler" ||
            $url_array[$pos+2]    == "send2friend" ||
            $url_array[$pos+2]    == "control_panel")) {
            if ($url_array[$pos+2] == "control_panel") $func = "userpannel";   
            else $func = $url_array[$pos+2];
            $_GET['func'] = $func;
            $_REQUEST['func'] = $func;
            $QUERY_STRING .= "&func=$func";
            return $QUERY_STRING;  
        }
        /*---------------------------------------------------------------------------*/
        // description: display special pages
        // variables: func=special, sorting=$var1
        elseif (isset($url_array[$pos+2]) && $url_array[$pos+2] !="" && $url_array[$pos+2]   == "special" ) {    
			$func = "special";
            $_GET['func'] = $func;
            $_REQUEST['func'] = $func;
            $QUERY_STRING .= "&func=$func";
            
			switch($url_array[$pos+3]) {
				case "top_rated":
					$specialsort = 'rating';
					break;
				case "last_added":
					$specialsort = 'lastadd';
					break;
				case "last_commented":
					$specialsort = 'lastcomment';		
					break;
			}
			
            $_GET['sorting'] = $specialsort;
            $_REQUEST['sorting'] = $specialsort;
            $QUERY_STRING .= "&sorting=$specialsort";
            return $QUERY_STRING;    
        } 
        /*---------------------------------------------------------------------------*/
        // description: passthrough some variables
        // variables: translated back from standard joomla core sef 
        elseif (isset($url_array[$pos+2]) 
        && $url_array[$pos+2] !="" 
        && ($url_array[$pos+2] == "func,editpic"
        || $url_array[$pos+2] == "func,deletepic"
        || $url_array[$pos+2] == "func,votepic"
        || $url_array[$pos+2] == "func,commentpic"
        || $url_array[$pos+2] == "func,deletecomment" )) { 
            for ( $ii=2; $ii < count($url_array); $ii++ ) {
                $temp = explode(',', $url_array[$ii]);
                $key = $temp[0];
                $val = $temp[1];
                $_GET[$key] = $val;
                $_REQUEST[$key] = $val;
                $QUERY_STRING .= "&$key=$val";
            }
            return $QUERY_STRING;
        }
        elseif ( preg_match("/pg(.*)\.html/",end($url_array)) ) {
			//$blankfilename = array_pop($url_array);
           	$pg = end($url_array);
           	$pg = split("pg",$pg);
           	$pg = split(".html",$pg[1]);
           	$blankfilename = array_pop($url_array);
           	
			$func = "viewcategory";
            $_GET['func'] = $func;
            $_REQUEST['func'] = $func;
            $QUERY_STRING .= "&func=$func";
            // remove the last entry from the array because it's a blank filename
            
            // figure out the category id
            $catid = datso_catid($url_array, $database);
            // add catid to path
            $_GET['catid'] = $catid;
            $_REQUEST['catid'] = $catid;
            $QUERY_STRING .= "&catid=$catid";
            
            $_GET['startpage'] = $pg[0];
            $_REQUEST['startpage'] = $pg[0];
            $QUERY_STRING .= "&startpage=".$pg[0]."";
            return $QUERY_STRING;
            
        }
        /*---------------------------------------------------------------------------*/
        // description: display the picture
        // variables: func=detail, id=$var1
        elseif ( preg_match("/\.html/",end($url_array)) ) {
            // we know that the function is detail
            $func = "detail";
            $_GET['func'] = $func;
            $_REQUEST['func'] = $func;
            $QUERY_STRING .= "&func=$func";
            // remove the image titlle from the array
            //$imgtitle1 = explode("photo_", array_pop($url_array));
			
            $imgtitle = datso_sefdecode(substr(array_pop($url_array), 6));
            // figure out the category id
            $catid = datso_catid($url_array, $database);
            // figure out the image id from catid and title
            $database->setQuery("SELECT id "
            ."FROM #__datsogallery "
            ."WHERE LOWER(imgtitle)='$imgtitle' "
            ."AND catid='$catid'");
            $id = $database->loadResult();
            // add id to path
            $_GET['id'] = $id;
            $_REQUEST['id'] = $id;
            $QUERY_STRING .= "&id=$id";
            return $QUERY_STRING;  
        }
        /*---------------------------------------------------------------------------*/
        // description: display the category
        // variables: func=viewcategory, catid=$var1
        elseif (isset($url_array[$pos+2]) && $url_array[$pos+2] !="" && $url_array[$pos+2] == "category") {     
			$func = "viewcategory";
            $_GET['func'] = $func;
            $_REQUEST['func'] = $func;
            $QUERY_STRING .= "&func=$func";

            $blankfilename = array_pop($url_array);
			$catid = datso_catid($url_array, $database);

            $_GET['catid'] = $catid;
            $_REQUEST['catid'] = $catid;
            $QUERY_STRING .= "&catid=$catid";
            return $QUERY_STRING;    
        } 
        /*---------------------------------------------------------------------------*/
        // description: display the category
        // variables: func=detail, id=$var1
        else {
            // display category is the only thing left to do, so set function
            $func = "viewcategory";
            $_GET['func'] = $func;
            $_REQUEST['func'] = $func;
            $QUERY_STRING .= "&func=$func";
            // remove the last entry from the array because it's a blank filename
            $blankfilename = array_pop($url_array);
            // figure out the category id
            $catid = datso_catid($url_array, $database);
            // add catid to path
            $_GET['catid'] = $catid;
            $_REQUEST['catid'] = $catid;
            $QUERY_STRING .= "&catid=$catid";
            return $QUERY_STRING;
        }
    }

}

/**
 * Get category id for current item
 *
 * @param array A list of URL parts
 * @param database A database connector objectstring $string
 * @return integer
 */
function datso_catid($url_array, &$database){
    $parent=0;
    for ( $ii=3; $ii < count($url_array); $ii++ ) {
        $catname=datso_sefdecode($url_array[$ii]);
        $database->setQuery("SELECT cid "
        ."FROM #__datsogallery_catg "
        ."WHERE name='$catname'"
        ."AND parent='$parent'");
        $catid = $database->loadResult();
        $parent=$catid;
    }
    return $catid;
}

/**
 * Get new string with new space filler etc...
 *
 * @param string $string
 * @return encoded string
 */
function datso_sefencode($string) {
    global $sefConfig, $sufix, $lowercase,$url_exception;
    
    if (empty($sefConfig)) {
    $ext_suffix = $sufix;
    $ext_space = _SEF_SPACE;
    $ext_lower = $lowercase;
    $ext_strip = $url_exception;
    
    } else {
    $ext_suffix = $sefConfig->encode_page_suffix;
    $ext_space = $sefConfig->encode_space_char;
    $ext_lower = $sefConfig->encode_lowercase;
    $ext_strip = array($sefConfig->encode_strip_chars);
    }

    $string = urlencode($string);
    $string = eregi_replace("%2F", "%10", $string);
    $string = eregi_replace($ext_space, "%11", $string);
    $string = eregi_replace("\+", $ext_space, $string);
    foreach ($ext_strip as $value) {
    $string = ereg_replace(urlencode($value), $value, $string);
    }
    if ($ext_lower) {
    $string = strtolower($string);
    }
    return $string;
}

/**
 * Get back to original string
 *
 * @param string $string
 * @return decoded string
 */
function datso_sefdecode($string) {
    global $sefConfig, $sufix;
    
    if (empty($sefConfig)) {
    $ext_suffix = $sufix;
    $ext_space = _SEF_SPACE;
    
    } else {
    $ext_suffix = $sefConfig->encode_page_suffix;
    $ext_space = $sefConfig->encode_space_char;
    }
    
    $string = eregi_replace($ext_suffix, "", $string);
    $string = eregi_replace($ext_space, "%20", $string);
    $string = eregi_replace("%11", $ext_space, $string);
    $string = eregi_replace("%10", "%2F", $string);
    $string = urldecode($string);
    $string = addslashes($string);
    
    return $string;
}
?>