<?php

  /**
  * @version	1.0
  * @package	DatsoGallery Search Plugin
  * @author 	Andrey Datso
  * @link 	    http://www.datso.fr
  * @copyright Copyright (C) 2004-2009 Andrey Datso. All rights reserved.
  */

  defined('_JEXEC') or die('Restricted access');
  $mainframe->registerEvent('onSearch', 'plgSearchDatsoGallery');
  $mainframe->registerEvent('onSearchAreas', 'plgSearchDatsoGalleryAreas');
  JPlugin::loadLanguage('plg_search_datsogallery');

  function &plgSearchDatsoGalleryAreas()
  {
    static $areas = array('datsogallery' => 'DatsoGallery');
    return $areas;
  }

  function plgSearchDatsoGallery($text, $phrase = '', $ordering = '', $areas = null)
  {
    $db = &JFactory::getDBO();
    $user = &JFactory::getUser();
    if (is_array($areas))
    {
      if (!array_intersect( $areas, array_keys( plgSearchDatsoGalleryAreas())))
      {
        return array();
      }
    }
    $plugin = &JPluginHelper::getPlugin('search', 'datsogallery');
    $pluginParams = new JParameter($plugin->params);
    $limit = $pluginParams->def('search_limit', 50);
    $text = trim($text);
    if ($text == '')
    {
      return array();
    }
    $wheres = array();
    switch ($phrase)
    {

      case 'exact' :
        $text = $db->Quote( '%' . $db->getEscaped($text, true) . '%', false );
        $wheres2 = array();
        $wheres2[] = 'LOWER(a.imgtitle) LIKE ' . $text;
        $where = '(' . implode(') OR (', $wheres2) . ')';
        break;

      case 'all' :
      case 'any' :
      default :
        $words = explode(' ', $text);
        $wheres = array();
        foreach ($words as $word)
        {
          $word = $db->Quote( '%' . $db->getEscaped($word, true) . '%', false );
          $wheres2 = array();
          $wheres2[] = 'a.imgtitle LIKE ' . $word;
          $wheres2[] = 'a.imgtext LIKE ' . $word;
          $wheres[] = implode(' OR ', $wheres2);
        }
        $where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
        break;
    }
    switch ($ordering)
    {

      case 'alpha' :
        $order = 'a.imgtitle ASC';
        break;

      case 'oldest' :
        $order = 'a.imgdate ASC';
        break;

      case 'popular' :
        $order = 'a.imgcounter DESC';
        break;

      case 'newest' :
        $order = 'a.imgdate DESC';
        break;

      default :
        $order = 'a.imgtitle ASC';
    }
    $searchdatsogallery = JText::_('DatsoGallery');
    $component = &JComponentHelper::getComponent('com_datsogallery');
    $menu = &JSite::getMenu();
    $ids = $menu->getItems('componentid', $component->id);
    $query = 'SELECT a.*, a.imgtitle AS title, a.imgdate AS created,'
    . ' CONCAT(a.imgtext) AS text,'
    . ' CONCAT_WS( " / ", ' . $db->Quote($searchdatsogallery) . ', b.name ) AS section,'
    . ' "0" AS browsernav'
    . ' FROM #__datsogallery AS a'
    . ' INNER JOIN #__datsogallery_catg AS b ON b.cid = a.catid'
    . ' WHERE ( ' . $where . ' )'
    . ' AND a.published = 1'
    . ' AND b.access <= ' . (int) $user->get('aid')
    . ' ORDER BY ' . $order
    ;
    $db->setQuery($query, 0, $limit);
    $rows = $db->loadObjectList();
    if (count($rows))
      foreach ($rows as $key => $row)
      {
        $rows[$key]->href = 'index.php?option=com_datsogallery&func=detail&catid=' . $row->catid . '&id=' . $row->id . '&Itemid=' . $ids[0]->id;
    }
    return $rows;
  }
